package rmi.progreseau.client;

import java.rmi.*;
import java.rmi.Naming;

import rmi.progreseau.common.PowerService;

import java.io.*;



//
//
// PowerServiceClient
//
//
public class PowerServiceClient 
{
	public static void main(String args[]) throws Exception
	{
		// Vérifier si l'user a bien entré une adresse de serveur RMI à contacter
		if (args.length != 1)
		{
			System.out.println("Veuillez entrer une adresse de serveur RMI.");
			System.exit(0);
		}

		PowerService service = null;
		
		// Appel du registre pour trouver le serveur
		try {
		service = (PowerService) Naming.lookup
			("rmi://" + args[0] + "/PowerService");
		}
		catch (java.rmi.NotBoundException e)
		{
			System.out.println("Impossible de trouver la classe PowerService. Le serveur et le registre RMI sont-ils bien démarrés ?");
			System.exit(0);
		}

		System.out.println("Incroyable client RMI  ('・△・)");
		
		
		while (true)
		{
			System.out.println 
			  ("1 - Carré d'un nombre");
			System.out.println 
			  ("2 - Puissance d'un nombre");
			System.out.println 
			  ("3 - Sortez moi d'ici"); System.out.println();
			  
			System.out.println("Entrer la commande désirée ci-dessous: ");

			BufferedReader buffer=new BufferedReader(new InputStreamReader(System.in));
			Integer selection =  new Integer(buffer.readLine());

			switch (selection)
			{
			case 1:
				System.out.println ("Votre nombre ?  ");
				selection =  new Integer(buffer.readLine());
					
				// Appel du serveur
				System.out.println ("La réponse est : " + service.carreNombre(selection));
				break;
			  
			case 2:
				System.out.println ("Votre nombre ?  ");
				selection =  new Integer(buffer.readLine());
				
				System.out.println ("Votre exposant ?  ");
				Integer exp =  new Integer(buffer.readLine());
				
				// Appel du serveur
				System.out.println ("La réponse est : " + service.puissanceNombre(selection, exp));
				break;
			  
			case 3:
				System.out.println("Adios !");
				System.exit(0);
				
			default :
				System.out.println ("Option Invalide.");
				break;
			}
		}
	}

}