package rmi.progreseau.server;

import java.math.*;
import java.rmi.*;
import java.rmi.server.*;

import rmi.progreseau.common.PowerService;


//Implémentation de l'interface PowerService
public class PowerServiceServer extends UnicastRemoteObject
implements PowerService
{
    public PowerServiceServer () throws RemoteException
    {
        super();
    }

    @Override
	public BigInteger carreNombre(int nbre) throws RemoteException {
		return puissanceNombre(nbre, 2); //wow
	}

	@Override
	public BigInteger puissanceNombre(int nbre, int exposant) throws RemoteException {
		String numrep = String.valueOf(nbre);
        BigInteger resultat = new BigInteger (numrep);

        resultat = resultat.pow(exposant);
        System.out.println("Reçu une demande pour "+nbre+" puissance "+exposant+". Le résultat est "+resultat);
        return resultat;
	}
    

    public static void main ( String args[] ) throws Exception
    {
    	
        // On crée une instance de notre serveur
        PowerServiceServer svr = new PowerServiceServer();

        // Qu'on attache au registre RMI pour le rendre visible des clients.
        Naming.bind ("PowerService", svr);

        System.out.println ("Incroyable serveur RMI  (・△・') ");
        System.out.println ("Service attaché au registre et disponible !");
    }

	
}